var oGlobalEnabler=null;

Ext.define('DSS.addon.EventMailer.GridPanel',
{

	extend : 'Ext.grid.Panel',

	config : {
		enableColumnHide : false,
		enableColumnMove : false,
		selType : 'rowmodel',
		viewConfig : {
			forceFit : true
		}
	},

	/** The event store */
	store : null,
	editorWindow : null,
	curSelectedEvent : null,
	btnNew:null,
	btnEdit:null,
	btnDelete:null,
	btnDisable:null,
	btnEnable:null,
	btnTest:null,
	
	/** DSS JSon class */
	property : 'DSS.json.Property',

	constructor : function(config) {
		
		var me=this;

		oGlobalEnabler=function (id,state)
		{
			if (state=="")
				state="false";
			if (state=="false")
			{
				dss.raiseEvent('event-mailer',{actions:'disable','id':id})
				me.waitAndReload();
			} else {
				dss.raiseEvent('event-mailer',{actions:'enable','id':id})
				me.waitAndReload();
			}
		};
		
		this.initConfig(config);
		this.property = Ext.create(this.property, config);
		
		this.btnNew=new Ext.create('Ext.button.Button',{
			text : _('Neue Nachricht'),
			iconCls : 'icon-add-action',
			handler : function() {
				me.curSelectedEvent = null;
				me.editorWindow.show();
				me.editorWindow.setValues(null);
			}
		});
		this.btnEdit=new Ext.create('Ext.button.Button',{
			text : _('Nachricht bearbeiten'),
			iconCls : 'icon-edit-action',
			disabled : true,
			handler : function() {
				var oParams={};
				oParams.id=me.curSelectedEvent.get('id');
				oParams.name=me.curSelectedEvent.get('name');
				oParams.triggers=me.curSelectedEvent.get('triggers');
				oParams.message=me.curSelectedEvent.get('message');
				oParams.defaultFooter=me.curSelectedEvent.get('defaultFooter');
				me.editorWindow.show();
				me.editorWindow.setValues(oParams);
			}
		});
		this.btnDelete=new Ext.create('Ext.button.Button',{
			text : _('Benachrichtigung l&ouml;schen'),
			iconCls : 'icon-delete-action',
			disabled : true,
			handler : function() {
				dss.raiseEvent('event-mailer',{actions:'delete',id:me.curSelectedEvent.get('id')});
				me.waitAndReload();
			}
		});
		this.btnDisable=new Ext.create('Ext.button.Button',{
			text : _('Benachrichtung deaktivieren'),
			iconCls : 'icon-disable-action',
			disabled : true,
			handler : function() {
				dss.raiseEvent('event-mailer',{actions:'disable',id:me.curSelectedEvent.get('id')});
				me.waitAndReload();
			}
		});
		this.btnEnable=new Ext.create('Ext.button.Button',{
			text : _('Benachrichtung aktivieren'),
			iconCls : 'icon-enable-action',
			hidden: true,
			disabled : true,
			handler : function() {
				dss.raiseEvent('event-mailer',{actions:'enable',id:me.curSelectedEvent.get('id')});
				me.waitAndReload();
			}
		});
		this.btnTest=new Ext.create('Ext.button.Button',{
			text : _('Benachrichtigung testen'),
			iconCls : 'icon-test-action',
			disabled : true,
			handler : function() {				
				dss.raiseEvent('event-mailer',{actions:'test',id:me.curSelectedEvent.get('id')});
			}

		});
		
		Ext.apply(this, {
			tbar : {
				items : [ this.btnNew, this.btnEdit, this.btnDisable, this.btnEnable,this.btnTest, '->', this.btnDelete ]}
		});
				
		this.callParent(arguments);
	},	
	waitAndReload:function() {
		var me=this;
		var iSubscriptID=Math.floor(Math.random() * 100000000000);
		dss.ajaxSyncRequest('/json/event/subscribe',{subscriptionID:iSubscriptID,name:'event-mailer-saved'});
		dss.ajaxAssyncRequestWithoutAnswer('/json/event/get',{subscriptionID:iSubscriptID,timeout:60*1000},
		function (){
			me.loadParameter();
			dss.ajaxAssyncRequestWithoutAnswer('/json/event/unsubscribe',{subscriptionID:iSubscriptID,name:'event-mailer-saved'});
		});
	},	


	loadParameter:function(me){
		if (me==null)
			me=this;
		var sString = dss.ajaxSyncRequest('/json/property/query',
			{
				'query' : '/scripts/event-mailer/values/*(*)/*(*)/*(*)'
			});
		var result=Ext.JSON.decode(sString);
		if (result.ok)		
			if (result.result!=null)
				if (result.result.values!=null) {
					var oArray=[];
					for (var iIndex=0;iIndex<result.result.values.length;iIndex++)
					{
						var oObject={};
						oObject.id=result.result.values[iIndex].id;
						oObject.disabled=result.result.values[iIndex].disabled;						
						oObject.name=result.result.values[iIndex].name;
						if (result.result.values[iIndex].defaultFooter)
							oObject.defaultFooter=result.result.values[iIndex].defaultFooter;
						else
							oObject.defaultFooter=false;
						if (result.result.values[iIndex][oObject.id] != null) {
							var oSubArray = result.result.values[iIndex][oObject.id];
							for ( var jIndex = 0; jIndex < oSubArray.length; jIndex++) {
								var oSubSubObject = oSubArray[jIndex];
								if (oSubSubObject.messageType != null) {
									oObject.message = {};
									oObject.message.messageType = oSubSubObject.messageType;
									oObject.message.receiver = oSubSubObject.receiver;
									oObject.message.subject = oSubSubObject.subject;
									oObject.message.message = oSubSubObject.messageBody;
								}
								if (oSubSubObject.triggers != null) {
									oObject.triggers=[];
									for (var kIndex=0;kIndex<oSubSubObject.triggers.length;kIndex++)
									{
										var resultObject=oSubSubObject.triggers[kIndex];
										var oTriggerObject={};
										for (var oKey in resultObject){
											oTriggerObject[oKey]=resultObject[oKey];	
										}
										oObject.triggers.push(oTriggerObject);
									}
								}
							}
						}						
						oArray.push(oObject);				
					}
					me.store.removeAll();
					me.store.add(oArray);				
				}
	},
	initComponent : function() {
		var me = this;

		me.store = Ext.create('Ext.data.Store', {
			storeId : 'emailStore',
			fields : [ 'disabled','name','id','message','triggers','defaultFooter' ],
			proxy : {
				type : 'memory',
				reader : {
					type : 'json',
					root : 'items'
				}
			}
		});

		var editorConfig = me.config;
		editorConfig.title = 'Nachrichteneigenschaften';
		editorConfig.staticControls = [{
			type : 'text',
			label : _('Name'),
			id : 'name'
		},{
			type : 'hidden',
			label : _('id'),
			id : 'id'
		}];
		editorConfig.tabControls = [ {
			tabLabel : 'Ausl&ouml;sende Handlung',
			content : [ {
				type : 'TriggerConfigurator',
				id : 'triggers'
			} ]
		}, {
			tabLabel : 'Bedingungen',
			content : [  ]
		} ,{
			tabLabel : 'Nachricht',
			content : [{
				type : 'MessageControl',
				id : 'message',
				title: "Nachricht"
			},{
				type : 'checkbox',
				id : 'defaultFooter',
				label: "Standardtext mit Beschreibung des ausl&ouml;senden Events anf&uuml;gen"
			}]
		} ];
		me.editorWindow = Ext.create(
				'DSS.component.Editor', editorConfig);
		me.on({selectionchange : function(view,
							selections, options) {
						var me = this;
						if (selections.length > 0) {
							me.curSelectedEvent = selections[0];
							me.btnEdit.setDisabled(false);
							me.btnDelete.setDisabled(false);
							me.btnDisable.setDisabled(me.curSelectedEvent.get('disabled'));
							me.btnDisable.setVisible(!me.curSelectedEvent.get('disabled'));
							me.btnEnable.setDisabled(!me.curSelectedEvent.get('disabled'));
							me.btnEnable.setVisible(me.curSelectedEvent.get('disabled'));
							me.btnTest.setDisabled(me.curSelectedEvent.get('disabled'));
						} else {
							me.curSelectedEvent = null;
							me.btnEdit.setDisabled(true);
							me.btnDelete.setDisabled(true);
							me.btnDisable.setDisabled(true);
							me.btnEnable.setDisabled(true);
							me.btnEnable.setVisible(false);
							me.btnTest.setDisabled(true);
						}
					}
				});
		me.editorWindow.on({
			'save': function (oValue)
			{
				dss.raiseEvent('event-mailer',{actions:'save',value:Ext.JSON.encode(oValue)})
				me.waitAndReload();
			}
		})
		me.callParent(arguments);
		me.initPage();
		me.loadParameter();
	}, // initComponent

	initPage : function() {
		/*var me = this, aptStore = null, onAptStoreLoaded = function() {

		};

		var aptStore = DSS.types.ActionModel.getApartmentStore();
		if (aptStore.isLoading()) {
			me.setLoading(true);
			aptStore.on('load', onAptStoreLoaded);
		} else {
			onAptStoreLoaded();
		}*/
	},

	viewConfig : {
		stripeRows : true
	},
	
	columns : [ 
			{
				id : 'col-status',
				header : _('Active'),
				dataIndex : 'disabled',
				renderer : function(val, metadata, record,
						colIdx, store, view) {
					return '<input type="checkbox" onclick="oGlobalEnabler(\'' + record.get('id') + '\',\''+record.get('disabled')+'\');"' + (!record.get('disabled') ? ' checked="true" >' : '>');
				},
				resizable : false,
				width : 50
			},
			{
				id : 'col-name',
				header : _('Name'),
				dataIndex : 'name',
				flex : 1
			},
			{
				id : 'col-actions',
				header : _('Ausl&ouml;sende Aktivit&auml;t'),
				dataIndex : 'id', // alibi index
				maintainFlex : true,
				flex : 1,
				sortable : false,
				renderer : function (val, metadata, record,
						colIdx, store, view)
						{
							var oRecord=record.get('triggers');
							var sResult="<table>";
							var f1tip=false;
							var f2tip=false;
							var f3tip=false;
							for (var iIndex=0;iIndex<oRecord.length;iIndex++) {
								var oAction=oRecord[iIndex];
								sResult+="<tr>";
								switch (oAction.type) {
									case 'zone-scene': { // scene, group,zone,force
										var sString =  '<td style="padding-right:5px;">'+ dss.staticDataModel.getImageForScene(
														oAction.zone,
														oAction.group,
														oAction.scene) + "</td>";
							
										sString += "<td>"
												+ dss.staticDataModel.getNameForScene(
														oAction.zone,
														oAction.group,
														oAction.scene);
										if (oAction.group!=0)
											sString +=" f&uuml;r " + dss.staticDataModel.getNameForGroup(oAction.zone, oAction.group);
										if (oAction.zone!=0)
											sString+= " in " + dss.staticDataModel.getNameForZone(oAction.zone);
										if (oAction.force)
											sString += ' !';
										sString += "</td>";
										sResult+=sString;
										break;
									}									
									case 'device-scene': {
										var oDevice = dss.staticDataModel
										.getDevice(oAction.dsid);

										var sString = oDevice.name + " in ";
										sString += dss.staticDataModel
												.getNameForZone(oDevice.ZoneID);
										switch (oAction.scene)
										{
										case 50:
											sString= 'Lokal aus von '
												+'<img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td>' + 
												sString + "</td>"; 
										break;
										case 51:
											sString= 'Lokal ein von '
												+'<img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td>' + 
												sString + "</td>"; 
										break;
										}
										sResult+='<td style="padding-right:5px;" colspan="2">'+sString;
										break;
									}
									case 'device-msg': { // value, dsid
										var oDevice = dss.staticDataModel
										.getDevice(oAction.dsid);

										var sString = oDevice.name + " in ";
										sString += dss.staticDataModel
												.getNameForZone(oDevice.ZoneID);
										switch (oAction.msg)
										{
											case 7:
											case 0:
												if (f1tip==false) {
													sString= '1x Tipp von ' +'<img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td>' + sString + "</td>";
													sResult+='<td style="padding-right:5px;" colspan="2">'+sString;
												}
												f1tip=true;
											break;
											case 8:
											case 1:
												if (f2tip==false) {
													sString= '2x Tipp von ' + '<img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td>' + sString + "</td>";
													sResult+='<td style="padding-right:5px;" colspan="2">'+sString;
												}
												f2tip=true;
											break;
											case 9:
											case 2:
												if (f3tip==false) {
													sString= '3x Tipp von ' + '<img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td>' + sString + "</td>";
													sResult+='<td style="padding-right:5px;" colspan="2">'+sString;
												}													
												f3tip=true;
											break;
											case 3:
												sString= '4x Tipp von ' + '<img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td>' + sString + "</td>";	
												sResult+='<td style="padding-right:5px;" colspan="2">'+sString;												 
											break;
											case 6: 
												sString= 'Halten von ' + '<img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td>' + sString + "</td>";
												sResult+='<td style="padding-right:5px;" colspan="2">'+sString;
											break;
											case 10:
												sString= 'Kurz-Lang-Klick von ' + '<img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td>' + sString + "</td>";
												sResult+='<td style="padding-right:5px;" colspan="2">'+sString;
											break;
										}
										
										break;
									}
									case 'custom-event': { // event
										sResult+='<td colspan="2">Highlevel Event: ' + oAction.event + '</td>';
										break;
									}
								}
								sResult+="</tr>";
							}
							return sResult+"</table>";
						}
			},{
				id : 'col-message',
				header : _('Nachricht'),
				dataIndex : 'message',
				renderer : function (val, metadata, record, colIdx, store, view)
					{
						var triggerObject = record.get('message');
						if (triggerObject.messageType=='email')
							return '<table><tr><td rowspan="3"><image src="images/dss/email.png"></td>'+
							       '<td rowspan="3" style="width:5px;"><image src="images/t.gif"></td>' + 
								   '<td>Empf&auml;nger:</td><td>'+ triggerObject.receiver +'</td></tr>'+
								   '<tr><td>Betreff:</td><td>' +triggerObject.subject+ '</td></tr>'+
								   '<tr><td>Nachricht:</td><td>'+ triggerObject.message+'</td></tr></table>';
						else
							return "eine Nachricht";
					},
				flex : 1
			}, 
			
    ]	
});

function pad(c) {
	var i = parseInt(c, 10);
	return (i < 10 ? '0' + i : c.toString());
}

